/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the PutOrganizationsOrganizationIdCxTemplatesIdStatusRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &PutOrganizationsOrganizationIdCxTemplatesIdStatusRequest{}

// PutOrganizationsOrganizationIdCxTemplatesIdStatusRequest struct for PutOrganizationsOrganizationIdCxTemplatesIdStatusRequest
type PutOrganizationsOrganizationIdCxTemplatesIdStatusRequest struct {
	Status string `json:"status"`
}

// NewPutOrganizationsOrganizationIdCxTemplatesIdStatusRequest instantiates a new PutOrganizationsOrganizationIdCxTemplatesIdStatusRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewPutOrganizationsOrganizationIdCxTemplatesIdStatusRequest(status string) *PutOrganizationsOrganizationIdCxTemplatesIdStatusRequest {
	this := PutOrganizationsOrganizationIdCxTemplatesIdStatusRequest{}
	this.Status = status
	return &this
}

// NewPutOrganizationsOrganizationIdCxTemplatesIdStatusRequestWithDefaults instantiates a new PutOrganizationsOrganizationIdCxTemplatesIdStatusRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewPutOrganizationsOrganizationIdCxTemplatesIdStatusRequestWithDefaults() *PutOrganizationsOrganizationIdCxTemplatesIdStatusRequest {
	this := PutOrganizationsOrganizationIdCxTemplatesIdStatusRequest{}
	return &this
}

// GetStatus returns the Status field value
func (o *PutOrganizationsOrganizationIdCxTemplatesIdStatusRequest) GetStatus() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Status
}

// GetStatusOk returns a tuple with the Status field value
// and a boolean to check if the value has been set.
func (o *PutOrganizationsOrganizationIdCxTemplatesIdStatusRequest) GetStatusOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Status, true
}

// SetStatus sets field value
func (o *PutOrganizationsOrganizationIdCxTemplatesIdStatusRequest) SetStatus(v string) {
	o.Status = v
}

func (o PutOrganizationsOrganizationIdCxTemplatesIdStatusRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o PutOrganizationsOrganizationIdCxTemplatesIdStatusRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["status"] = o.Status
	return toSerialize, nil
}

type NullablePutOrganizationsOrganizationIdCxTemplatesIdStatusRequest struct {
	value *PutOrganizationsOrganizationIdCxTemplatesIdStatusRequest
	isSet bool
}

func (v NullablePutOrganizationsOrganizationIdCxTemplatesIdStatusRequest) Get() *PutOrganizationsOrganizationIdCxTemplatesIdStatusRequest {
	return v.value
}

func (v *NullablePutOrganizationsOrganizationIdCxTemplatesIdStatusRequest) Set(val *PutOrganizationsOrganizationIdCxTemplatesIdStatusRequest) {
	v.value = val
	v.isSet = true
}

func (v NullablePutOrganizationsOrganizationIdCxTemplatesIdStatusRequest) IsSet() bool {
	return v.isSet
}

func (v *NullablePutOrganizationsOrganizationIdCxTemplatesIdStatusRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullablePutOrganizationsOrganizationIdCxTemplatesIdStatusRequest(val *PutOrganizationsOrganizationIdCxTemplatesIdStatusRequest) *NullablePutOrganizationsOrganizationIdCxTemplatesIdStatusRequest {
	return &NullablePutOrganizationsOrganizationIdCxTemplatesIdStatusRequest{value: val, isSet: true}
}

func (v NullablePutOrganizationsOrganizationIdCxTemplatesIdStatusRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullablePutOrganizationsOrganizationIdCxTemplatesIdStatusRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


